' =============== Cylon3v1.bas ================

'	Program runs on a PICAXE-20M.
'	Eight segments of a Red LED bar display
'	are connected to outputs 0-7 (pins 18-11).
'	Each bar has a 470 ohm resistor to ground.
'	Current draw is > 7.25mA per LED.
'	When all nine are lit, current = 65mA.
'	(Max for 20M is 200mA, so it's OK)

' === Constants ===
	symbol abit = 100	' used to slow down

' === Variables ===
	symbol index = b0	' used in for/next loops
	symbol  LEDs = b1	' used to vary lit LEDs	
	
' === Directives ===
	#com 5						' specify serial port
	#picaxe 20M				' specify processor
	#terminal off			' disable terminal window

' ============ Begin Main Program =============
do
	outpins = %00000001					' light 1
	pause abit
	outpins = %00000011					' light 2
	pause abit	
	
	LEDs = %00000111						' initialize LEDs 
	
	for index = 1 to 6					' for 6 triplets
		outpins = LEDs						' light 3
		LEDs = LEDs * 2						' shift right     
	  pause abit
	next index
	
	outpins = %11000000					' light 2
	pause abit
	outpins = %10000000					' light 1
	pause abit
	outpins = %00000000					' light none
	wait 1
	outpins = %10000000					' light 1
	pause abit	
	outpins = %11000000					' light 2
	pause abit
	
	LEDs = %11100000						' initialize LEDs 
	
	for index = 6 to 1 step -1	' for 6 triplets
		outpins = LEDs						' light 3
		LEDs = LEDs / 2						' shift left
	  pause abit
	next index
	
	outpins = %00000011					' light 2
	pause abit
	outpins = %00000001					' light 1
	pause abit
	outpins = %00000000					' light none
	wait 1	
loop