' ============== SimpleCylon.bas ==============
'
'		Program runs on a PICAXE-20M.
'		Eight segments of a Red LED bar display
'		are connected to outputs 0-7 (pins 18-11).
'		Each bar has a 470 ohm resistor to ground.
'		Current draw is > 7.25mA per LED.
'		When all nine are lit, current = 65mA.

' === Constants ===
	symbol abit  = 100	' used to slow down

' === Variables ===
	symbol index = b0		' used in for/next loop
	symbol   LED = b1		' used to vary lit LED	
	
' === Directives ===
	#com 5							' specify serial port
	#picaxe 20M					' specify processor
	#terminal off				' disable terminal window
	
' ============ Begin Main Program =============
	LED = %00000001			' initialize LED
   
do
	for index = 2 to 8	' for 7 LEDs
	   outpins = LED		' light it
		 LED = LED * 2		' shift right one LED	     
	   pause abit				' slow down a bit
	next index					' loop
	
	for index = 7 to 1 step -1	' for 7 LEDs
		 outpins = LED		' light it
		 LED = LED / 2		' shift left one LED   
	   pause abit				' slow down a bit
	next index					' loop
loop