' ============== SimpleCylon2.bas =================

'			Program runs on a PICAXE-20M.
'			Eight segments of a Red LED bar display
'			are connected to outputs 7-0 (pins 11-18).
'			Each bar has a 470 ohm resistor to ground.
'			Current draw is > 7.25mA per LED.
'			When all nine are lit, current = 65mA.

' === Constants ===
	symbol abit  = 100			' used in pauses

' === Variables ===
	symbol index = b0				' used in for/next loops
	symbol  LEDs = b1				' used to vary lit LEDs	
		
' === Directives ===
	#com 5									' specify serial port
	#picaxe 20M							' specify processor
	#terminal off						' disable terminal window
	
' ============== Begin Main Program ===============	
	LEDs = %00000011						' initialize LEDs

do
	for index = 2 to 7					' for 6 pair of LEDs
		outpins = LEDs						' light them
		  LEDs = LEDs * 2		 			' shift right    
	   pause abit								' slow down a bit
	next index
	
	for index = 6 to 1 step -1	' for 7 pair of LEDs
		outpins = LEDs						' light them
		  LEDs = LEDs / 2	 				' shift left      
	   pause abit								' slow down a bit
	next index	
loop