' ================== Cylon3v1.bas ==================

'			Program runs on a PICAXE-20M2.
'			Eight segments of a Red LED bar display
'			are connected to outputs 0-7 (pins 18-11).
'			Each bar has a 470 ohm resistor to ground.
'			Current draw is > 7.25mA per LED.
'			When all nine are lit, current = 65mA.
'			(Max for 20M is 200mA, so it's OK)

' === Constants ===
	symbol abit = 100				' used to slow down

' === Variables ===
	symbol index = b0				' used in for/next loops
	symbol  LEDs = outpinsB	' used to vary lit LEDs				
	
' === Directives ===
	#com 3									' specify serial port
	#picaxe 20M2						' specify processor
	#no_data								' save download time
	#terminal off						' disable terminal window

' =============== Begin Main Program ===============
	dirsB = %11111111				' all outputs
	
do
	LEDs = %00000001				' light 1
	pause abit
	LEDs = %00000011				' light 2
	pause abit	
	LEDs = %00000111				' light 3
	pause abit
	
	for index = 1 to 6
		LEDs = LEDs * 2				' shift right	     
	   pause abit
	next index
	
	LEDs = %11000000				' light 2
	pause abit
	LEDs = %10000000				' light 1
	pause abit
	LEDs = %00000000				' light none
	wait 1
	LEDs = %10000000				' light 1
	pause abit	
	LEDs = %11000000				' light 2
	pause abit
	LEDs =%11100000 
	pause abit
	
	for index = 5 to 0 step -1
		LEDs = LEDs / 2				' shift left
	  pause abit
	next index
	
	LEDs = %00000011				' light 2
	pause abit
	LEDs = %00000001				' light 1
	pause abit
	LEDs = %00000000				' light none
	wait 1	
loop