' =============== SimpleCylon.bas =================
'
'		Program runs on a PICAXE-20M2.
'		Eight segments of a Red LED bar display
'		are connected to the 20M2s output portB.
'		Each bar has a 470 ohm resistor to ground.
'		Current draw is > 7.25mA per LED.
'		When all nine are lit, current = 65mA.

' === Constants ===
	symbol abit  = 100			' used in pauses

' === Variables ===
	symbol index = b0				' used in for/next loops
	symbol   LED = outpinsB	' used to vary lit LED				
	
' === Directives ===
	#com 3									' specify serial port
	#picaxe 20M2						' specify processor
	#no_data								' save download time
	#terminal off						' disable terminal window
	
' ============= Begin Main Program ================
	dirsB = %11111111				' all pins are outputs
	LED = %00000001					' light the first LED
	pause abit
	
do
	for index = 2 to 8			' for 7 LEDs
		LED = LED * 2					' shift right one LED
	  pause abit						' slow down a bit
	next index

	for index = 7 to 1 step -1
		LED = LED / 2	 				' shift left one LED   
	  pause abit						' slow down a bit
	next index
loop