' ================= ButtonIntrpt.bas ==================
'
'		Program runs on a PICAXE-20M. Seven segments of
' 	an LED bar display are connected to outputs 0-6.
'
' 	An input switch is connected to input 1 (pin 9)
'		and held low with a 4.7k resistor.

' === Constants ===
  symbol abit = 200				' used for pauses
  symbol  btn = input1		' push-button on input 1
	
' === Variables ===
  symbol LEDs = b0				' btn-press counter
	
' === Directives ===
  #com 5									' specify com port
  #picaxe 20M							' specify processor
  #terminal off						' disable terminal window

' === Begin Main Program =====================
  LEDs = 1								' start the count at 1
  outpins = LEDs					' and display it
	setint %00000010, %00000010	' enable interrupt
	
do
  wait 1									' simulate a longer program
loop

' ======= End Main Program - Subroutines Follow =======

interrupt:
	inc LEDs								' increment the count
	outpins = LEDs					' and display it
	pause 50								' de-bounce time for press
	
tarry:
	if btn is on then tarry ' wait for release
	pause 50								' de-bounce time for release
	
	if LEDs = 127 then
		LEDs = 1							' reset the count to 1
	endif 
		
	setint %00000010, %00000010	' re-enable interrupt
	return