' ======================== Mary.bas =========================

'	Program runs on a PICAXE-20M. Seven segments of an LED
' bar display are connected to outputs 0-6 (pins 18-12).
'
' Note: The piezo is in a totally different position than the
' M2 project in the EG book, because output 7 is the only
' remaining output pin available on the 20M processor.

' === Constants ===
  symbol piezo = 7		 	' piezo on output 7 (pin 11)

  symbol C1 = $00				' C quarter-note
  symbol C4 = $80				' C whole-note
  symbol D1 = $02				' D quarter-note
  symbol D2 = $C2				' D half-note
  symbol E1 = $04				' E quarter-note
  symbol E2 = $C4				' E half-note
  symbol G1 = $07				' G quarter-note
  symbol G2 = $C7				' G half-note 
	
' === Variables ===
  symbol note = b0
  symbol tone = b1
  
' === Directives ===
  #com 3								' specify com port
  #picaxe 20M						' specify processor
  #terminal off					' disable terminal window

' =================== Begin Main Program ====================
do
	for note = 0 to 12
	  lookup note,(E1,D1,C1,D1,E1,E1,E2,D1,D1,D2,E1,G1,G2),tone
	  gosub PlayNote
	next note	
	outpins = %00000000
	pause 40
	
	for note = 0 to 12
	  lookup note,(E1,D1,C1,D1,E1,E1,E1,E1,D1,D1,E1,D1,C4),tone
	  gosub PlayNote
	next note
   outpins = %00000000
   wait 1
 loop
   
' ========== End Main Program - Subroutines Follow ==========

PlayNote:

	select case tone
     case C1,C4
       outpins = %01000000
     case D1,D2
       outpins = %00100000
     case E1,E2
       outpins = %00010000
     case G1,G2
       outpins = %00000100
   end select 
   	  
   tune 7,4,(tone)    
   return