' ================= ButtonIntrpt.bas ==================

'  Program runs on a PICAXE-20M2. Seven segments of an
'  LED bar display are connected to outputs B.0-B.6.
'
'  An input switch is connected to input C.1 (pin 9)
'  and held low with a 4.7k resistor.

' === Constants ===	
  symbol abit = 200	   		' used for pauses
	
' === Variables ===
  symbol  btn = pinC.1	  ' push-button on input C.1
  symbol LEDs = outpinsB	' btn-press counter
	
' === Directives ===
  #com 3									' specify com port
  #picaxe 20M2						' specify processor
  #no_data								' save download time

' ================ Begin Main Program ================
  dirsB = %11111111				' all outputs
  dirsC = %10111101				' C.1 & C.6 are inputs
  LEDs  = %00000001				' start the count at 1
  setint %00000010, %00000010, C	' enable interrupt
	
do
  wait 1		' simulate a longer program
loop

' ======= End Main Program - Subroutines follow ======

interrupt:
  inc LEDs								' increment the count
  pause 50								' de-bounce time for press
	
tarry:
  if btn is on then tarry ' wait for release
  pause 50								' de-bounce time for release
	
  if LEDs = 127 then
    LEDs = 1							' reset the count to 1
  endif 
		
  setint %00000010, %00000010, C ' re-enable interrupt
  return