' ======================== Mary.bas =========================

'  Program runs on a PICAXE-20M2. Seven segments of an LED
'  bar display are connected to outputs B.0 through B.6
'  A piezo beeper is connected to output C.7.

' === Constants ===	
  symbol piezo = C.7		' piezo on output C.7 (pin 3)

  symbol C1 = $00				' C quarter-note
  symbol C4 = $80				' C whole-note
  symbol D1 = $02				' D quarter-note
  symbol D2 = $C2				' D half-note
  symbol E1 = $04				' E quarter-note
  symbol E2 = $C4				' E half-note
  symbol G1 = $07				' G quarter-note
  symbol G2 = $C7				' G half-note 
	
' === Variables ===
  symbol LEDs = outpinsB
  symbol note = b0
  symbol tone = b1
  
' === Directives ===
  #com 3								' specify com port
  #picaxe 20M2					' specify processor
  #no_data							' save download time
  #terminal off					' disable terminal window

' =================== Begin Main Program ====================
do
  for note = 0 to 12
    lookup note,(E1,D1,C1,D1,E1,E1,E2,D1,D1,D2,E1,G1,G2),tone
    gosub PlayNote
  next note	
  LEDs = %00000000
  pause 40
	
  for note = 0 to 12
    lookup note,(E1,D1,C1,D1,E1,E1,E1,E1,D1,D1,E1,D1,C4),tone
    gosub PlayNote
  next note
  LEDs = %00000000
  wait 1
loop
   
' ========== End Main Program - Subroutines Follow ==========

PlayNote:

  select case tone
     case C1,C4
 	 LEDs = %01000000
     case D1,D2
 	 LEDs = %00100000
     case E1,E2
 	 LEDs = %00010000
     case G1,G2
 	 LEDs = %00000100
  end select 
   	  
  tune piezo,4,(tone)
  return