' ================ LogicProbe.bas ================

' 	This program runs on a PICAXE-08M at 8 MHz.
'		It implements a 3-state digital logic probe.

'  === Constants ===
symbol Probe = 1					' probe on ADC input 1
symbol Red   = %00000001	' red LED on (output 0)
symbol Green = %00000100	' grn LED on (output 2)
symbol Blank = %00000000	' both LEDs off
	
'	ADC input boundries			' ADC values (Open=134)
' -------------------     ' ---------------------
symbol Hi = 190						' High = 254
symbol Lo =  70						' Low  =  10	

' === Variables ===
symbol ADC = b0						' ADC measurement
	
' === Directives ===
#com 3										' specify serial port
#picaxe 08M								' specify processor
#terminal off							' disable terminal window	
		
' ============== Begin Main Program ===============
setfreq m8
dirs = %00000101					' LEDs on outputs 0 & 2

do
	readadc probe, ADC			' get ADC value
	
		select case ADC				' light corresponding LED
		case > Hi
			outpins = Red
		case < Lo
			outpins = Green
		else
			outpins = Blank
	endselect	
loop