' ===================== VoltageDiv2.bas =====================

'	This program runs on a PICAXE-08M processor at 4 MHz.
'	It repetitively updates an ADC voltage measurement on ADC1. 
' The program also calculates the actual voltage value from
'	the ADC result and displays it in the Terminal Window.

' === Constants ===
	symbol  LED = 4					' LED on output 4 (pin 3) 
	symbol Vdiv = 1					' voltage divider on ADC1

' === Variables ===
' Variables b0-b4 are directly used in the bintoascii
' command, so we can't use them here.

	symbol ADCval = b5			' used to store ADC value
	symbol    Vin = w3   		' need a word variable (see text)

' === Directives ===
   #com 3									' specify com port
   #picaxe 08M						' specify processor
   #terminal 4800					' open terminal window

' =================== Begin Main Program ====================

do
	high LED											' for debugging
	readadc Vdiv,ADCval						' get ADC value
	pause 500											' slow down	
	low LED	
	Vin = ADCval * 100 / 51				' compute voltage (see text)
	bintoascii Vin,b4, b3, b2, b1, b0	
	sertxd (b2,".", b1, b0," volts",cr,lf) ' send result to TW
	pause 500		
loop