' ================ LogicProbe.bas =================

' 	This program runs on a PICAXE-08M2 at 8 MHz.
'		It implements a 3-state digital logic probe.

' === Constants ===
symbol Probe = C.1				' probe on C.1
symbol Red   = %00000001	' red LED on (output 0)
symbol Green = %00000100	' grn LED on (output 2)
symbol Blank = %00000000	' both LEDs off
	
'	ADC input boundaries		' ADC values (Open=134)
' --------------------    ' ---------------------
symbol Hi = 190						' High = 254
symbol Lo =  70						' Low  =  10	

' === Variables ===
symbol ADCval = b0				' ADC measurement
symbol LEDs   = outpinsC

' === Directives ===
#com 3										' specify serial port
#picaxe 08M2							' specify processor	
#terminal off							' disable terminal window

' ============== Begin Main Program ===============
setfreq m8
dirsC = %00000101					' LEDs on outputs 2 & 0

do
	readadc Probe, ADCval		'get ADC value
	
		select case ADCval		' light corresponding LED
		case > Hi
			LEDs = Red
		case < Lo
			LEDs = Green
		else
			LEDs = Blank
	endselect	
loop