' ==================== BattMon.bas ====================
'
' 	Program runs on a PICAXE-20X2 and measures the
' 	analog value of its three-cell battery supply.

' === Constants ===
	symbol abit = 500						' used in pauses
	symbol LED  = B.7						' debugging LED on B.7
	
' === Variables ===
' Variables b0 through b4 are directly used in the
' bintoascii command - so we cant use them here.

  symbol ADCval = w3					' ADC result
	symbol batV   = w4					' supply voltage 
	
' === Directives ===
	#com 3											' specify com port
	#picaxe 20X2								' specify processor
	#no_data										' reduce download time
	#no_table										' reduce download time
	#terminal 9600							' open terminal window
	
' ================ Begin Main Program =================
do
	high LED										' for debugging
	pause abit
	
	calibadc10 ADCval						' get ADC reading
	batV = 52378 / ADCval				' convert it (see text)
	batV = batV * 2							' (see text)
	
  low LED
  pause abit
  
  bintoascii batV, b4, b3, b2, b1, b0			' get digits
  sertxd (b2,".", b1, b0," volts",cr,lf)	' send to TW
loop