' ========================== TV-IRtoMP.bas ==========================

'	This program runs on a PICAXE-08M processor at 4 MHz. It waits
'	for a keypress from an SIRC TV remote control. When it's received,
'	it encodes & transmits it as single byte to the Master Processor.
'
'	Note: "infra" is a built-in variable assigned to b13.

' === Constants ===
	symbol toMP   = 2						' serout line to master processor
	symbol fromMP = 4						' input line from master processor
	
' === Variables ===
	symbol junk = w0						' pulsin requires a word variable
	
' === Directives ===
  #com 4											' specify com port
  #picaxe 08M									' specify processor	
  #terminal off								' disable the terminal window

' ======================= Begin Main Program ========================

do
	infrain2										' wait here for infrared input
	
	select case infra						' implement encoding scheme
		case < 9
			inc infra								' make digits 1-9 & data correspond
		case 9
			infra = 0								' make 0 = 0
		case < 22
			infra = infra - 6				' lower the remaining values
		else
			goto skip:							' ignore any other keys
	endselect
	
	high toMP										' tell MP that data is available
	pulsin fromMP,1, junk				' junk is junk; we're just waiting
	low toMP										' prepare to send data
	
	serout toMP,N2400_4,(infra) ' send remote keypress to Master
skip:
	pause 500										' avoid multiple key-presses
loop