' ======================== LCDtest.bas =========================

'     Program runs on a PICAXE-20X2 at 8MHz & sends 8-bit data
'     to an HD44780 16x2 LCD display.

' === Constants ===
	symbol enable = C.7				' LCD enable pin connected to C.7
	symbol RegSel = C.4				' LCD RegSel pin connected to C.4

' === Variables ===
	symbol  char = b0					' character to be sent to LCD
	symbol index = b1					' used as counter in For-Next loops
	symbol newB.6 = outpinC.1	' replacement pin for B.6 (hserin)
' Note:  newB.6 is a variable because its value can change
	
' === Directives ===
	#com 3										' specify download port (AxRed)
	#picaxe 20X2							' specify processor
	#no_data									' save time downloading
	#terminal off							' disable terminal window
	
' === Table ====================
	Table  0, ("Evil Genius LCD ")
	Table 16, ("Serial Display! ")

' ===================== Begin Main Program =====================
 	dirsB = %10111111				' set portB as outputs (except B.6)
 	dirsC = %10111111				' set portC as outputs (except C.6)
 	
' === Initialize the LCD ===								 
	pause 200								' pause 200 mS for LCD initialization
	char = 56								' setup for 8-bits, 2 lines & 5X7 dots
 	gosub OutCmd						' send instruction to LCD
	char = 12								' display on, cursor off
	gosub OutCmd						' send instruction to LCD	
	
' === Main Program Loop - Send data to the LCD ===	
do
  	char = 1							' clear display & go home	
 	gosub OutCmd						' send instruction to LCD
	wait 1
	
 	for index = 0 to 15
 	  readtable index, char	' send line one to LCD
 	  gosub OutTxt
 	next index
 	wait 1
 	
  	char = 192						' move cursor to start of line two	
 	gosub OutCmd						' send instruction to LCD
 	 		
  	for index = 16 to 31	' send line two to LCD
 	  readtable index, char
 	  gosub OutTxt
 	next index
 	wait 4
loop
	
' ========== End Main Program - Subroutines Follow ==========

OutCmd:
	low RegSel							' set up for command byte
	goto Doit								' do it	
OutTxt:
	high RegSel							' set up for text byte
Doit:
	outpinsB = char					' load byte onto outpinsB
	newB.6 = bit6						' load bit6 onto pinC,1
	pulsout enable,1				' send data
	return