' ================== SeroutToLCD.bas ===================

'	This program runs on a PICAXE-20X2 processor at 8 MHz.
'	It sends serial data to the Evil Genius LCD display.
'
'	Note 1: The "Display Clear" command (DC) must always
'	be sent on a line by itself or next character is lost.
'
'	Note 2: A minimum delay of 30mS is required between
'	serial outputs to allow time for LCD to display data.

' === Constants ===
	symbol abit  = 40
	symbol toLCD = B.7
	
'	=== LCD Commands ===
	symbol DC =   1			' display clear & cursor home
	symbol C0 =  12			' cursor off
	symbol C1 =  14			' cursor on (no blink)
	symbol CB =  15			' cursor blink	
	symbol L1 = 128			' cursor at position 1 of line 1	
	symbol L2 = 192			' cursor at position 1 of line 2
	
' === Directives ===
	#com3								' specify COM port (AxRed)
	#picaxe 20X2				' specify compiler mode
	#no_data						' save time downloading
	#no_table						' save time downloading
	#terminal off				' disable terminal window	
	
' ================ Begin Main Program ==================

	wait 1							' allow time for LCD to initialize

do
	serout toLCD, N4800_8, (DC)
	wait 1
		
	serout toLCD, N4800_8, (L1,"PICAXE-20X2 LCD ")
	pause abit
	serout toLCD, N4800_8, (L2,"Serial Display ")
	wait 2
	
	serout toLCD, N4800_8, (L1,"The Evil Genius ")
	pause abit
	serout toLCD, N4800_8, (L2," strikes again! ")
	wait 10
loop