' ===================== KeypadTest.bas ====================

' Program runs on a 20X2. It receives data from the keypad
' peripheral & sends it to the terminal window for display.

' === Constants =========
	symbol fromKP = C.6
	symbol toKP   = C.7

' === Variables ===
  symbol char = b0
	symbol KPflag = pinC.6
' Note:  KPflag is a variable because its value can change	
	
' === Directives ===
	#com 3												' specify com port
	#picaxe 20X2									' specify processor	
	#no_data											' reduce download time
	#no_table											' reduce download time
	#terminal 9600								' open terminal window
	
' =================== Begin Main Program ==================
	dirsc = %10111111
	low toKP													' initialize to low
	
do
	pause 100													' pretend to be busy
	if KPflag = 1 then gosub getChar	' go get new input
loop

' ========== End Main Program - Subroutines Follow ========

getChar:
	pulsout toKP,2										' 10uS "send it" pulse
	pause 1														' allow time for keypad
																		' to lower its ouput
	serin fromKP,N2400_8,char					' get char		
   sertxd (char,cr,lf)							' send it to terminal
   return