' ============== KeypadDriver.bas ===============

' This program uses an ADC approach to decoding
' a 4X4 matrix keypad. It notifies MP that a new
' character is available, then sends it serially.

' === Constants ===
	symbol fromKP = 2			' Keypad ADC input
	symbol fromMP = 3			' input (DTR) from MP
	symbol   toMP = 4			' serout (TxD) to MP

' === Variables ===
	symbol  key = w0			' ADC key value
	symbol char = b2			' corresponding char
	symbol junk = b3			' throwaway char	
	
' === Directives ===
	#com 4								' specify serial port
	#picaxe 08M						' specify processor
	#terminal off					' disable terminal window
	
' ============= Begin Main Program ==============

setfreq m8									' as fast as possible

do 	
wait_for_keypress:
  readadc fromKP, junk
	if junk < 5 then wait_for_keypress

	pause 60									' debounce keypress	
	readadc10 fromKP, key			' get ADC value
		
wait_for_release:	
	readadc fromKP, junk
	if junk > 5 then wait_for_release
	
	select case key						' decode keypress
		case < 369 : char = 49	' 1
		case < 385 : char = 50	' 2
		case < 402 : char = 51	' 3
		case < 434 : char = 65	' A
		case < 450 : char = 52	' 4
		case < 474 : char = 53	' 5
		case < 500 : char = 54	' 6
		case < 551 : char = 66	' B
		case < 587 : char = 65	' 7
		case < 634 : char = 56	' 8
		case < 674 : char = 57	' 9
		case < 733 : char = 67	' C
		case < 804 : char = 42	' *
		case < 885 : char = 48	' 0
		case < 977 : char = 35	' #
		else       : char = 68	' D
	end select
	
	high toMP									' data available
	pulsin fromMP,1, junk			' junk is junk,
	low toMP									' we're just waiting
	pause 2										' allow time for MP
														' to set up serin
	serout toMP,N2400_8,(char)' send char to MP	
loop