' ======================= keypad2.bas =========================

' Program uses an ADC approach to decoding a 4X4 matrix keypad.
' It sends the decoded character to the terminal window.
	
' === Variables ===
symbol key  = w0		' used in adc10; word variable is required
symbol char = b2		' the char that corresponds to key value
symbol junk = b3		' throwaway variable used for debouncing		
	
' === Directives ===
#com 3							' specify serial port
#picaxe 08M2				' specify processor
#terminal 9600			' open terminal window
		
' ==================== Begin Main Program =====================

setfreq m8
dirsC = %00010011

do 	
wait_for_keypress:
  readadc 2, junk
  if junk < 5 then wait_for_keypress
  pause 100											' debounce key-press
  readadc10 2, key							' get ADC value
		
wait_for_release:	
  readadc 2, junk
  if junk > 5 then wait_for_release
	
  select case key								'decode key-press
' (Replace the theoretical values with actual values.)
		case < 369 : char = 49			' 1
		case < 385 : char = 50			' 2
		case < 402 : char = 51			' 3
		case < 434 : char = 65			' A
		case < 450 : char = 52			' 4
		case < 474 : char = 53			' 5
		case < 500 : char = 54			' 6
		case < 551 : char = 66			' B
		case < 587 : char = 65			' 7
		case < 634 : char = 56			' 8
		case < 674 : char = 57			' 9
		case < 733 : char = 67			' C
		case < 804 : char = 42			' *
		case < 885 : char = 48			' 0
		case < 977 : char = 35			' #
		else       : char = 68			' D
  end select

  sertxd ("char = ",char,cr,lf)	' send decoded char to terminal
loop