' ========================== MAXhelp20X2.bas ==========================

' This program runs on a PICAXE-20X2 & controls a MAX7219 LED display
' driver. The MAX7219 is connected to a 4-digit, 7-segment LED display.
' The program displays the word "HELP"

' === Constants ===
' Hardware interface to the MAX7219 
	symbol load = C.2		' briefly pulse C.2 to transfer data to LEDs

' Register addresses for the MAX7219
	symbol decode =  9	' decode register; specify digits to decode
	symbol brite  = 10	' intensity (brightness) register; 15 = 100%
	symbol scan   = 11	' scan-limit register; specify how many digits
	symbol on_off = 12	' 1 = display on; 0 = display off 

' === Directives ===
	#com	3							' specify the com port
	#picaxe 20X2				' specify the PICAXE processor
	#no_data						' speed up the download
	#no_table						' speed up the download
	#terminal off				' disable the terminal window
		
' ======================== Begin Main Program =========================
	setfreq m64
	dirsb = %11111111							' set portB as all outputs
	dirsc = %10111111							' set portC as outputs (except C.6)	
	hspisetup spimode00,spislow		' set up hspi

' Initialize MAX7219
	hspiout (scan,3)							' set scan limit for digits 0-3
	pulsout load,1
	
	hspiout (brite,5)							' set brightness to 5 (15 = 100%)
	pulsout load,1
	
	hspiout (decode,15)						' set BCD decoding for digits 0-3
	pulsout load,1
		
	hspiout (on_off,1)						' turn display on
	pulsout load,1

' Send data to the four digits
	hspiout (1,12)								' 1st LED from left = "H"
	pulsout load,1
	
	hspiout (2,11)								' 2nd LED from left = "E"
	pulsout load,1
	
	hspiout (3,13)								' 3rd LED from left = "L"
	pulsout load,1
	
	hspiout (4,14)								' 4th LED from left = "P"
	pulsout load,1