' ===================== KeypadNew.bas =====================

' This program uses an ADC approach to decoding a matrix
' keypad that has had all its keys rotated and rearranged.
' It sends the decoded character to the Terminal Window.

' === Variables ====
	symbol key  = w0	' used in adc10; word variable required
	symbol char = b2	' char that corresponds to key value
	symbol junk = b3	' throwaway var used for de-bouncing	
	
' === Directives ===
	#com 3						' specify serial port
	#picaxe 20X2			' specify processor
	#no_data					' speed up download
	#no_table					' speed up download
	#terminal 19200		' open terminal at 19200 baud for 16MHz

' =================== Begin Main Program ==================
setfreq m16					' set clock speed

do
wait_for_keypress:
  	readadc 7, junk
	if junk < 5 then wait_for_keypress

	pause 50					' de-bounce key
	readadc10 7, key	' get ADC value
		
wait_for_release:	
	readadc 7, junk
	if junk > 5 then wait_for_release
	
	select case key		'decode key
		case < 369 : char = 65	' A
		case < 385 : char = 82	' R
		case < 402 : char = 68	' D
		case < 434 : char = 76	' L
		case < 450 : char = 48	' 0
		case < 474 : char = 57	' 9
		case < 500 : char = 85	' U
		case < 551 : char = 66	' B
		case < 587 : char = 56	' 8
		case < 634 : char = 55	' 7
		case < 674 : char = 54	' 6
		case < 733 : char = 53	' 5
		case < 804 : char = 52	' 4
		case < 885 : char = 51	' 3
		case < 977 : char = 50	' 2
		else       : char = 49	' 1
	end select
	
	sertxd ("char = ",char,cr,lf)
loop