' ========================== TestLCD.bas ==========================

' Program runs on a 20X2 at 16MHz & sends 8-bit data to a 16X2
' LCD display. B.4 is replaced by C.3 & B.6 is replaced by A.0.

' === Constants ===
	symbol cmnd   = 0					' used to set up for cmd/txt byte	
	symbol text   = 1					' used to set up for cmd/txt byte type
	symbol enable = C.7				' LCD enable pin connected to pinC.7
  symbol RegSel = C.4				' LCD RegSel pin
  
' === Variables ===
	symbol  char = b0					' character to be sent to LCD
	symbol index = b1					' used as counter in For-Next loops
' Note: The following are variables becuase their values can change
	symbol newB.4 = outpinC.3	' replacement pin for B.4
	symbol newB.6 = outpinA.0	' replacement pin for B.6 (hserin pin)
	
' === Directives ===
	#com 4										' specify download port (AxRed)
	#picaxe 20X2							' specify processor
	#no_data									' save time downloading
	#terminal off							' make sure terminal is off
	
' === Table ====================
	Table  0, ("The Evil Genius ")
	Table 16, ("Capstone Project")
	Table 32, ("A Multi-Function")
	Table 48, ("PeripheralDevice")
	
' ====================== Begin Main Program =======================
	setfreq m16
	dirsB = %11101111					' configure pinB.4 as  input
	dirsC = %10111111					' configure pinC.6 as  input

' === Initialize the LCD ===								 
	pause 400									' pause 200 mS for LCD initialization
	char = 56									' setup for 8-bits, 2 lines & 5X7 dots
 	gosub OutCmd							' send instruction to LCD
	char = 12									' display on, cursor off
	gosub OutCmd							' send instruction to LCD	
	
' === Main Program Loop - Send data to the LCD ===	
do
  	char = 1								' clear display & go home	
 	gosub OutCmd							' send instruction to LCD
	
	sound C.1,(40,100)
										
 	for index = 0 to 15
 	  readtable index, char		' send line one to LCD
 	  gosub OutTxt
 	next index

  	char = 192							' move cursor to start of line two	
 	gosub OutCmd							' send instruction to LCD
 	 		
  	for index = 16 to 31		' send line two to LCD
 	  readtable index, char
 	  gosub OutTxt
 	next index
 	
 	wait 4
 	
 	char = 1									' clear display & go home	
 	gosub OutCmd							' send instruction to LCD
	
	 sound C.1,(60,100)
	
 	for index = 32 to 47
 	  readtable index, char		' send line one to LCD
 	  gosub OutTxt
 	next index
 	
  	char = 192							' move cursor to start of line two	
 	gosub OutCmd							' send instruction to LCD
 	 		
  	for index = 48 to 63		' send line two to LCD
 	  readtable index, char
 	  gosub OutTxt
 	next index
 	
 	wait 4
loop
	
' ============= End Main Program - Subroutines Follow =============

OutCmd:
	low RegSel								' set up for command byte
	goto Doit									' do it	
OutTxt:
	high RegSel								' set up for text byte
Doit:
	outpinsB = char						' load byte onto outpinsB
	newB.4 = bit4							' substitute outpinC.3 for pinB.4
	newB.6 = bit6							' substitute outpinA.0 for pinB.6
	pulsout enable,2					' send data
	return