' =========================== TestMPD.bas ===========================

' This program tests the Evil Genius Multi-function Peripheral Device

' === Constants ===
	symbol cmnd   = 0						' used to set up for cmd/txt byte	
	symbol text   = 1						' used to set up for cmd/txt byte
	symbol enable = C.7					' LCD enable pin
	symbol RegSel = C.4					' LCD RegSel pin
	
' === Variables ===
	symbol char   = b0					' character to be sent to LCD
	symbol junk   = b1
	symbol key    = w1
	symbol index  = b4					' used in for/next loop
	
' Note: The following are variables because their values can change
	symbol newB.4 = outpinC.3		' replacement pin for B.4
	symbol newB.6 = outpinA.0		' replacement pin for B.6 (hserin pin)

' === Directives ===
	#com 3											' specify COM port (AxGreen)
	#picaxe20X2									' specify compiler mode
	#no_data										' save time downloading
	#no_table										' save time downloading
	#terminal off								' disable terminal window	

' ======================= Begin Main Program ========================
setfreq m16
dirsB = %11101111							' configure pinB.4 as input
dirsC = %10111111							' configure pinC.6 as input	
adcsetup = %0000000001000000	' enable ADC6 (see adcsetup in Manual)
	
' === Initialize the LCD ===								 
pause 400											' pause 200 mS for LCD initialization
char = 56											' setup for 8-bits,2 lines & 5X8 dots
low RegSel										' set up for command byte
gosub OutByte2								' send instruction to LCD
char = 12											' display on, cursor off
gosub OutByte									' send instruction to LCD	
char =  1											' clear display and go home	
gosub OutByte									' send instruction to LCD
wait 1
	
' === Main Program Loop - Get Key-press and display it on LCD ===
do	
wait_for_keypress:
  	readadc 6, junk
	if junk < 5 then wait_for_keypress

	pause 10										' de-bounce key
	readadc10 6, key						' get ADC value
		
wait_for_release:	
	readadc 6, junk
	if junk > 5 then wait_for_release
	
	select case key				' decode key
		case < 364 : char = 65		' A
		case < 379 : char = 82		' R
		case < 395 : char = 68		' D
		case < 422 : char = 76		' L
		case < 452 : char = 48		' 0
		case < 476 : char = 57		' 9
		case < 502 : char = 85		' U
		case < 542 : char = 66		' B
		case < 588 : char = 56		' 8
		case < 629 : char = 55		' 7
		case < 674 : char = 54		' 6
		case < 733 : char = 53		' 5
		case < 804 : char = 52		' 4
		case < 884 : char = 51		' 3
		case < 976 : char = 50		' 2
		else       : char = 49		' 1
	end select

	if char = "B" then					' if "B" then
		char = 1									' clear LCD display
		sound C.1,(20,150)
		gosub OutByte
	else												' else
		sound C.1,(50,50)
		gosub OutByte							' display char
	endif
loop

' ============== End Main Program - Subroutines Follow ==============
OutByte:
	select case char					
		case 32 to 127						' text
			high RegSel						
		else											' commands
			low RegSel			
	endselect
	
Outbyte2:
	outpinsB = char							' load character onto outpinsB
	newB.4 = bit4								' substitute outpinC.3 for pinB.4
	newB.6 = bit6								' substitute outpinA.0 for pinB.6
	pulsout enable,2						' send data
	
	return