' ========== Exp1&2-DirectionTest.bas =========

' Program runs on the 20X2 EG master processor.
' It demonstrates L298 motor-direction control.

' === Constants ===
	symbol enable = C.5

' === Directives ===
	#com 4							' specify com port
	#picaxe 20X2				' specify processor
	#no_data						' save time downloading
	#no_table						' save time downloading
	#terminal 9600			' open terminal window
	
' ============= Begin Main Program ============

do
	sertxd ("Forward",CR,LF)
	gosub fwd						' demo each direction
	wait 2
	
	sertxd ("Reverse",CR,LF)
	gosub bak
	wait 2
	
	sertxd ("Left",CR,LF)
	gosub left
	wait 2
	
	sertxd ("Right",CR,LF)	
	gosub right
	wait 2
loop

' === End Main Program - subroutines follow ===
	
fwd: 									' go forward
	gosub stopp					' always stop first
	high B.0						' setup for forward
	low  B.2
	high B.5
	low  B.7
	high enable					' enable output
	return

bak: 									' go in reverse
	gosub stopp					' always stop first
	low  B.0						' setup for reverse
	high B.2
	low  B.5
	high B.7
	high enable					' enable output
	return		
	
left:									 ' go left
	gosub stopp					' always stop first
	low  B.0						' setup for left turn
	high B.2
	high B.5
	low  B.7
	high enable					' enable output
	return	
	
right: 								' go right
	gosub stopp					' always stop first
	high B.0						' setup for right turn
	low  B.2
	low  B.5
	high B.7
	high enable					' enable output
	return	
	
stopp: 								' stop
	low enable					' disable output
	wait 2
	return