' ============ Exp3-SpeedTest.bas =============

' Program demonstrates DC motor speed control
' using pwmout and pwmduty commands.

' === Constants ===
	symbol enable = C.5
	
' === Directives ===
	#com 3								' specify com port
	#picaxe 20X2					' specify processor
	#no_data							' save time downloading
	#no_table							' save time downloading
	#terminal 9600				' open terminal window
	
' ============ Begin Main Program =============

	low enable						' make C.5 an output
	pwmout enable, 99, 0  ' set up PWM (0% duty)
												' 5kHz PWM @ 8MHz clock
do
	gosub stopp
	high B.0							' set up for forward
	low  B.2
	high B.5
	low  B.7
	sertxd ("Forward Fast",CR,LF)
	pwmduty enable, 400		' 100% duty
	wait 2
	
	gosub stopp
	high B.0							' set up for forward
	low  B.2
	high B.5
	low  B.7
	sertxd ("Forward Slow",CR,LF)
	pwmduty enable, 300		' 75% duty
	wait 2
loop

' === End Main Program - subroutines follow ===	

stopp: 									' stop
	pwmduty enable, 0			' disable output
	sertxd ("Stop",CR,LF)
	wait 1
	return