' =============== EG18 EZ0toTerm.bas ===============

' Program uses a MaxSonar EZ0 to measure distance
' to nearest object & sends results to the Terminal.

' === Constants ===
	symbol EZ0 = 7					' EZ0 on A.7
	symbol LED = 5					' debugging LED on B.5

' === Variables ===
	symbol dist = w0				' data from EZ0	

' === Directives ===
	#com 3									' specify serial port
	#PICAXE 20X2						' specify processor
	#no_data								' save time downloading
	#no_table								' save time downloading
	#terminal 9600					' open Terminal Window
	
' =============== Begin Main Program ===============

setfreq m8

do
  high LED								' for debugging
  wait 1
  readadc10 EZ0,dist			' get EZ0 raw data
  dist = dist / 2					' convert to inches
  sertxd ("Distance = ",#dist,cr,lf)
  low LED
  wait 1
loop