' ================= IRmotorControl.bas ==================
'
' Program runs on the 20X2 master processor. It receives
' data from the IR-TV Module, which controls 2 DC motors.

' === Constants ===
	symbol fromIR = C.1
	symbol toIR   = C.4
	symbol enable = C.5

' === Variables ===
  symbol cmnd   = b0
	symbol IRflag = pinC.1		' as usual, this is a var
		
' === Directives ===
	#com 3										' specify com port
	#picaxe 20X2							' specify processor
	#no_data									' reduce download time
	#no_table									' reduce download time
	#terminal off							' disable terminal window

' ================= Begin Main Program ==================

do
	pause 100									' pretend to be busy
	if IRflag = 1 then				' data available
		gosub getData						' so go get it
		select case cmnd				' and move accordingly
			case 16
				gosub fwd
			case 17
				gosub bak
			case 18
				gosub right
			case 19
				gosub left
			case 20
				gosub stopp
		end select
	endif	
loop

' ======== End Main Program - Subroutines Follow ========

getData:
	pulsout toIR,10						'50uS "send it" pulse	
	serin fromIR,N2400_8,cmnd		
   return
   
fwd: 												' go forward
	gosub stopp								' always stop first
	high B.0									' setup for forward
	low  B.2
	high B.5
	low  B.7
	high enable								' enable output
	return

bak: 												' go in reverse
	gosub stopp								' always stop first
	low  B.0									' setup for reverse
	high B.2
	low  B.5
	high B.7
	high enable								' enable output
	return		
	
left:												' spin left
	gosub stopp								' always stop first
	low  B.0									' setup for left turn
	high B.2
	high B.5
	low  B.7
	high enable								' enable output
	return	
	
right: 											' spin right
	gosub stopp								' always stop first
	high B.0									' setup for right turn
	low  B.2
	low  B.5
	high B.7
	high enable								' enable output
	return	
	
stopp: 											' stop
	low enable								' disable output
	wait 2
	return	